require 'telegram/url'
require 'telegram/reply/request'

module Telegram
  module Reply

    def forward_message(chat_id: @chat.id, from_chat_id:, message_id:, **options)
      url     = Telegram::URL.new(@telegram_bot_token).forward_message
      params  = {
                  chat_id: chat_id,
                  from_chat_id: from_chat_id,
                  message_id: message_id,
                  disable_notification: options[:disable_notification].presence
                }
      
      Telegram::Reply::SEND(url: url, params: params)
    end
  end
end