require 'telegram/url'
require 'telegram/reply/request'

module Telegram
  module Reply

    def send_message(chat_id: @chat.id, text:, parse_mode: 'html', **options)
      url     = Telegram::URL.new(@telegram_bot_token).send_message
      params  = {
                  chat_id: chat_id,
                  text: text,
                  parse_mode: parse_mode,
                  disable_web_page_preview: options[:disable_web_page_preview].presence,
                  disable_notification: options[:disable_notification].presence,
                  reply_to_message_id: options[:reply_to_message_id].presence,
                  reply_markup: options[:reply_markup].presence
                }
      
      Telegram::Reply::SEND(url: url, params: params)
    end
  end
end