require 'telegram/url'
require 'telegram/reply/request'

module Telegram
  module Reply

    def send_photo(chat_id: @chat.id, photo:, **options)
      url     = Telegram::URL.new(@telegram_bot_token).send_photo
      params  = {
                  chat_id: chat_id,
                  photo: photo,
                  caption: options[:caption].presence,
                  parse_mode: options[:parse_mode].presence,
                  disable_notification: options[:disable_notification].presence,
                  reply_to_message_id: options[:reply_to_message_id].presence,
                  reply_markup: options[:reply_markup].presence
                }
      
      Telegram::Reply::SEND(url: url, params: params)
    end
  end
end